## CoglDisplay: Setup a display pipeline

CoglDisplay: Setup a display pipeline — Common aspects of a display pipeline

## Functions

CoglBool | cogl_is_display ()
CoglDisplay * | cogl_display_new ()
CoglRenderer * | cogl_display_get_renderer ()
CoglBool | cogl_display_setup ()
void | cogl_gdl_display_set_plane ()
void | cogl_wayland_display_set_compositor_display ()

## Types and Values

| CoglDisplay

## Description

The basic intention for this object is to let the application configure common display preferences before creating a context, and there are a few different aspects to this...

Firstly there are options directly relating to the physical display pipeline that is currently being used including the digital to analogue conversion hardware and the screens the user sees.

Another aspect is that display options may constrain or affect how onscreen framebuffers should later be configured. The original rationale for the display object in fact was to let us handle GLX and EGLs requirements that framebuffers must be "compatible" with the config associated with the current context meaning we have to force the user to describe how they would like to create their onscreen windows before we can choose a suitable fbconfig and create a GLContext.

## Functions

### cogl_is_display ()

    CoglBool
    cogl_is_display (void *object);

Gets whether the given object references a CoglDisplay.

#### Parameters

object | A CoglObject pointer |

#### Returns

`TRUE` if the object references a CoglDisplay and `FALSE` otherwise.

Since: 1.10

Stability Level: Unstable

### cogl_display_new ()

    CoglDisplay *
    cogl_display_new (CoglRenderer *renderer,
                      CoglOnscreenTemplate *onscreen_template);

Explicitly allocates a new CoglDisplay object to encapsulate the common state of the display pipeline that applies to the whole application.

Many applications don't need to explicitly use `cogl_display_new()` and can just jump straight to `cogl_context_new()` and pass a `NULL` display argument so Cogl will automatically connect and setup a renderer and display.

A `display` can only be made for a specific choice of renderer which is why this takes the `renderer` argument.

A common use for explicitly allocating a display object is to define a template for allocating onscreen framebuffers which is what the `onscreen_template` argument is for, or alternatively you can use `cogl_display_set_onscreen_template()`.

When a display is first allocated via `cogl_display_new()` it is in a mutable configuration mode. It's designed this way so we can extend the apis available for configuring a display without requiring huge numbers of constructor arguments.

When you have finished configuring a display object you can optionally call `cogl_display_setup()` to explicitly apply the configuration and check for errors. Alternaitvely you can pass the display to `cogl_context_new()` and Cogl will implicitly apply your configuration but if there are errors then the application will abort with a message. For simple applications with no fallback options then relying on the implicit setup can be fine.

#### Parameters

renderer | A CoglRenderer |
onscreen_template | A CoglOnscreenTemplate |

#### Returns

A newly allocated CoglDisplay object in a mutable configuration mode.

[transfer full]

Since: 1.10

Stability Level: Unstable

### cogl_display_get_renderer ()

    CoglRenderer *
    cogl_display_get_renderer (CoglDisplay *display);

Queries the CoglRenderer associated with the given `display` .

#### Parameters

display | a CoglDisplay |

#### Returns

The associated CoglRenderer.

[transfer none]

Since: 1.10

Stability Level: Unstable

### cogl_display_setup ()

    CoglBool
    cogl_display_setup (CoglDisplay *display,
                        CoglError **error);

Explicitly sets up the given `display` object. Use of this api is optional since Cogl will internally setup the display if not done explicitly.

When a display is first allocated via `cogl_display_new()` it is in a mutable configuration mode. This allows us to extend the apis available for configuring a display without requiring huge numbers of constructor arguments.

Its possible to request a configuration that might not be supportable on the current system and so this api provides a means to apply the configuration explicitly but if it fails then an exception will be returned so you can handle the error gracefully and perhaps fall back to an alternative configuration.

If you instead rely on Cogl implicitly calling `cogl_display_setup()` for you then if there is an error with the configuration you won't get an opportunity to handle that and the application may abort with a message. For simple applications that don't have any fallback options this behaviour may be fine.

#### Parameters

display | a CoglDisplay |
error | return location for a CoglError |

#### Returns

Returns `TRUE` if there was no error, else it returns `FALSE` and returns an exception via `error` .

Since: 1.10

Stability Level: Unstable

### cogl_gdl_display_set_plane ()

    void
    cogl_gdl_display_set_plane (CoglDisplay *display,
                                gdl_plane_id_t plane);

Request that Cogl output to a specific GDL overlay `plane` .

#### Parameters

display | a CoglDisplay |
plane | the GDL plane id |

Since: 1.10

Stability Level: Unstable

### cogl_wayland_display_set_compositor_display ()

    void
    cogl_wayland_display_set_compositor_display
                                   (CoglDisplay *display,
                                    struct wl_display *wayland_display);

Informs Cogl of a compositor's Wayland display pointer. This enables Cogl to register private wayland extensions required to pass buffers between the clients and compositor.

#### Parameters

display | a CoglDisplay |
wayland_display | A compositor's Wayland display pointer |

Since: 1.10

Stability Level: Unstable

## Types and Values

### CoglDisplay

    typedef struct _CoglDisplay CoglDisplay;